
wood_list = {
  [0] = "minecraft:oak_log",
  [1] = "minecraft:dark_oak_log",
  [2] = "minecraft:spruce_log",
}

local function is_wood(block_data)
  for i=0, #wood_list do
    if block_data["name"] == wood_list[i] then
      return true
    end
  end
  return false
end

local function check_for_wood()
  for i=0, 3 do
    turtle.turnLeft()
    block_found, block_data = turtle.inspect()
    if is_wood(block_data) then
      turtle.dig()
      turtle.forward()
      check_for_wood()
      turtle.back()
    end
  end

  block_found, block_data = turtle.inspectUp()
  if is_wood(block_data) then
    turtle.digUp()
    turtle.up()
    check_for_wood()
    turtle.down()
  end

  block_found, block_data = turtle.inspectDown()
  if is_wood(block_data) then
    turtle.digDown()
    turtle.down()
    check_for_wood()
    turtle.up()
  end
end

function place_tree()
  local has_block, block_data = turtle.inspect()
  if has_block then
    print("sapling already planted")
  else
    for i=1, 16 do
      turtle.select(i)
      local item_detail = turtle.getItemDetail()
      if item_detail ~= nil then
        if item_detail.name == "minecraft:spruce_sapling" then
          local has_block, block_data = turtle.inspect()
          if not has_block then
            turtle.up()
            turtle.forward()
            for i=0, 3 do
              turtle.placeDown()
              turtle.forward()
              turtle.turnRight()
            end
            turtle.back()
            turtle.down()
          end
        end
      end
    end
  end
end

--print(textutils.serialise(block_data))
while true do
  for k=0, 100 do
    print(k)
    local has_block, block_data = turtle.inspect()
    if has_block then
      if block_data.name == "minecraft:spruce_sapling" then
        print("found sapling")
      elseif block_data.name == "minecraft:spruce_log" then
        print("found tree")
        check_for_wood()
        for j=1, 16 do
          turtle.select(j)
          item_detail = turtle.getItemDetail()
          if item_detail ~= nil then
            place_tree()
            if item_detail.name == "minecraft:spruce_log" or item_detail.name == "minecraft:bamboo" then
              turtle.dropDown()
            end
          end
        end
      end
    end
    sleep(5)
  end
end
